Bug 1128609 - Misaligment versions between community BOM(CR11) and EAP 6.3.0.GA
Summary: Misaligment versions between community BOM(CR11) and EAP 6.3.0.GA
Keywords:
Status: VERIFIED
Alias: None
Product: JBoss BPMS Platform 6
Classification: Retired
Component: Build and Assembly
Version: 6.1.0
Hardware: Unspecified
OS: Unspecified
urgent
high
Target Milestone: ER1
: 6.1.0
Assignee: Ryan Zhang
QA Contact: Lukáš Petrovický
URL:
Whiteboard:
Depends On: 1128640 1128981 1128983
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-08-11 08:06 UTC by Ryan Zhang
Modified: 2019-01-01 02:57 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Ryan Zhang 2014-08-11 08:06:33 UTC
Description of problem:
After comparing the community BOM (CR11) with EAP 6.3.0.GA supported bom. I got the following differences. 

Please let us know that is there particular reason that we can't use the same version?
If there is no equiverlant community release, please use the most closer versions near the EAP ones.

Here is the plan for DR2:
1)For DR2, I should use the EAP versions if there is no particular warning on the differences.
2)Fix this please for DR3 if again no particular reasons for the misalignment.

[1]:EAP 6.3 GA supported BOM list: http://download.eng.rdu2.redhat.com/released/JBEAP-6/6.3.0/jboss-eap-6.3.0-supported-GAVs.txt
Differences:
- <version.org.hibernate>4.2.12.Final</version.org.hibernate>
+ <version.org.hibernate>4.2.14.SP1-redhat-1</version.org.hibernate>

- <version.org.hibernate.commons.annotations>4.0.2.Final</version.org.hibernate.commons.annotations>
- <version.org.hornetq>2.3.18.Final</version.org.hornetq>
- <version.org.infinispan>5.2.10.Final</version.org.infinispan>
+ <version.org.hibernate.commons.annotations>4.0.1.Final-redhat-2</version.org.hibernate.commons.annotations>
+ <version.org.hornetq>2.3.20.Final-redhat-1</version.org.hornetq>

- <version.org.jboss.resteasy>2.3.7.Final</version.org.jboss.resteasy>
+ <version.org.jboss.resteasy>2.3.8.Final-redhat-3</version.org.jboss.resteasy>

- <version.org.jboss.weld.weld>1.1.21.Final</version.org.jboss.weld.weld>
- <version.org.jboss.weld.weld-api>1.1.Final</version.org.jboss.weld.weld-api>
+ <version.org.jboss.staxmapper>1.1.0.Final-redhat-2</version.org.jboss.staxmapper>
+ <version.org.jboss.weld.weld>1.1.23.Final-redhat-1</version.org.jboss.weld.weld>

- <version.org.jdom>1.1.3</version.org.jdom>
+ <version.org.jdom>1.1.2.redhat-4</version.org.jdom>

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Comment 2 Ryan Zhang 2014-08-11 08:33:49 UTC
One more versions needs to be udpated:
jbpmmigration from 0.12->0.13
(noticed that 0.13 has been shipped in BPMS 6.0.2.GA)

Comment 3 Petr Široký 2014-08-11 11:34:18 UTC
Hello Ryan,

I do agree that we should align the versions as much as possible with the EAP 6.3. However, I think in some cases it's just not practical (e.g. EAP uses too old version and drools/jbpm needs features from the newer one). My question is: can we just override the versions and use those that come from community BOM? I am not sure how would this work with modules, but it seems to be the only way in some cases. 

I strongly believe that the product should use the exact same versions as the community (e.g. just add the -redhat-X suffix). Otherwise there could arise  incompatibilities between different versions and we will end-up with something that works in community and does not work in product (and there were cases in past that suffered from the same issue).

Comment 5 Shelly McGowan 2014-08-13 04:31:18 UTC
I've made the changes to sync with EAP 6.3 as requested by productization:
https://github.com/smcgowan/jboss-integration-platform-bom/commit/56b7b5832a5186bba86c9456779cfbc74c75ef64

There is no community release of hibernate 4.2.14.SP1 so I went to 4.2.15.Final.
I concur with Petr above, though, if the IP BOM reflects a higher, more recent version, the layer should take precedence.

Comment 6 Ryan Zhang 2014-08-13 05:13:23 UTC
(In reply to Petr Siroky from comment #3)
> Hello Ryan,
> 
> I do agree that we should align the versions as much as possible with the
> EAP 6.3. However, I think in some cases it's just not practical (e.g. EAP
> uses too old version and drools/jbpm needs features from the newer one). My
> question is: can we just override the versions and use those that come from
> community BOM? I am not sure how would this work with modules, but it seems
> to be the only way in some cases. 
Yes. We should highlight them case by case. Because I suspect that most cases are that we can make them use the same version. 
> 
> I strongly believe that the product should use the exact same versions as
> the community (e.g. just add the -redhat-X suffix). Otherwise there could
> arise  incompatibilities between different versions and we will end-up with
> something that works in community and does not work in product (and there
> were cases in past that suffered from the same issue).
I agreed.

Comment 7 Ryan Zhang 2014-08-13 05:15:39 UTC
Thanks Shelly!
(In reply to Shelly McGowan from comment #5)
> I've made the changes to sync with EAP 6.3 as requested by productization:
> https://github.com/smcgowan/jboss-integration-platform-bom/commit/
> 56b7b5832a5186bba86c9456779cfbc74c75ef64
> 
> There is no community release of hibernate 4.2.14.SP1 so I went to
> 4.2.15.Final.
> I concur with Petr above, though, if the IP BOM reflects a higher, more
> recent version, the layer should take precedence.

Comment 8 Gail Badner 2014-08-13 23:54:11 UTC
I am not quite following the discussion here, but I will try to explain how the version of hibernate-orm in EAP 6.3.0 aligns with the community versions.

The version of hibernate-orm that is in EAP 6.3.0 uses the tag, 	4.2.14.SP1-redhat-1, that was created on the 4.2.14.SP1-redhat branch. There is no community version that corresponds with 4.2.14.SP1-redhat-1. 

4.2.14.SP1-redhat-1 is functionally the same as the community version, 4.2.14.Final, except that it includes the cherry-picked fix for HHH-9268.

The community version 4.2.15.Final includes the fix for HHH-9268, plus 5 other fixes: https://hibernate.atlassian.net/issues/?jql=fixVersion%20%3D%204.2.15%20AND%20project%20%3D%20HHH .

Comment 9 Ryan Zhang 2014-08-14 02:38:37 UTC
Thanks Gail for your explaination.
Can I understand that 4.2.15.Final is preferable because of the fix for HHH-9268?

(In reply to Gail Badner from comment #8)
> I am not quite following the discussion here, but I will try to explain how
> the version of hibernate-orm in EAP 6.3.0 aligns with the community versions.
> 
> The version of hibernate-orm that is in EAP 6.3.0 uses the tag, 
> 4.2.14.SP1-redhat-1, that was created on the 4.2.14.SP1-redhat branch. There
> is no community version that corresponds with 4.2.14.SP1-redhat-1. 
> 
> 4.2.14.SP1-redhat-1 is functionally the same as the community version,
> 4.2.14.Final, except that it includes the cherry-picked fix for HHH-9268.
> 
> The community version 4.2.15.Final includes the fix for HHH-9268, plus 5
> other fixes:
> https://hibernate.atlassian.net/issues/?jql=fixVersion%20%3D%204.2.
> 15%20AND%20project%20%3D%20HHH .

Comment 10 Gail Badner 2014-08-14 09:04:49 UTC
Ryan, I'm not sure how to answer this question. I'm not sure what would make one version "preferable" to the other.

I would say that 4.2.14.Final is "closer" to 4.2.14.SP1-redhat-1.

Most of the fixes in 4.2.15.Final will go into the version of hibernate-orm in EAP 6.3.1.

I don't understand what this means:

> ... if the IP BOM reflects a higher, more
> recent version, the layer should take precedence.

I'll ask about this on #jbossas in the morning (Seattle local time). Once I understand I can give a better answer.

Comment 11 Ryan Zhang 2014-08-14 11:22:13 UTC
Thanks again Gail!
Quote from Dave's email on the similar issue. (dstahl@redhat.com) for reference.
"
Hi Andrea,

As of right now, there are no plans to build a 4.2.14.SP1 community release.
After 4.2.14.Final was released, a regression was found that needed to be fixed 
for EAP 6.3.0 but the community branch already had additional commits so we did an 
internal release with only the necessary commits to mitigate risk.  The 
regressions were also fixed upstream and are included in the hibernate 4.2.15.Final
release (although that does also include a few other bug fixes not in 4.2.14.SP1-redhat-1).
Not sure if that helps at all - do you specifically need to use the community release 
rather than the internal release?

Thanks,
Dave

----- Original Message -----
> From: "Andrea Vibelli" <avibelli@redhat.com>
> To: "Paul Gier" <pgier@redhat.com>
> Cc: "SOA-P Team" redhat.com>
> Sent: Tuesday, July 29, 2014 12:23:46 PM
> Subject: Hibernate supported version in EAP-6.3.0.ER10
>
> Hi Paul,
> I have taken a look at the supported dependencies of ER10
> (http://download.devel.redhat.com/devel/candidates/JBEAP/JBEAP-6.3.0.ER10/jboss-eap-6.3.0.ER10-supported-GAVs.txt).
> I have noticed that the supported version of Hibernate
> org.hibernate:hibernate-core:4.2.14.SP1-redhat-1 does not have an equivalent
> in Maven Central, I found a 4.2.14.Final version.
> Are you going to support 4.2.14.Final or are you publishing 4.2.14.SP1 to
> Maven Central (or whom should I ask)?
>
> I know it's a million dollar question, but when do you think it would be safe
> for layered product to have the EAP6.3.0.GA BOMs imported and inherited in
> MEAD? So that we could start layering on top of the GA versions?
>
> Thanks a lot
> Andrea
>
>
"
(In reply to Gail Badner from comment #10)
> Ryan, I'm not sure how to answer this question. I'm not sure what would make
> one version "preferable" to the other.
> 
> I would say that 4.2.14.Final is "closer" to 4.2.14.SP1-redhat-1.
> 
> Most of the fixes in 4.2.15.Final will go into the version of hibernate-orm
> in EAP 6.3.1.
> 
> I don't understand what this means:
> 
> > ... if the IP BOM reflects a higher, more
> > recent version, the layer should take precedence.
> 
> I'll ask about this on #jbossas in the morning (Seattle local time). Once I
> understand I can give a better answer.

Comment 12 Shelly McGowan 2014-08-14 13:09:38 UTC
Because there is no community version of hibernate 4.2.14.SP1, what I would suggest is the community IP BOM use 4.2.15.Final (as in the pull request).  However, due to the product alignment requirements, B*MS productization team should use the 4.2.14.SP1-redhat-1 artifact.   Once there is a productized version of 4.2.15.Final from the EAP stream (perhaps 6.3.1) the product builds can use that.

Comment 13 Shelly McGowan 2014-08-14 13:46:03 UTC
I've created a pull request for discussion with upsream project collaborators:
https://github.com/jboss-integration/jboss-integration-platform-bom/pull/84

Comment 14 Shelly McGowan 2014-08-14 13:56:24 UTC
@Ryan, the pull request was rejected as there is no resteasy 2.3.8.Final community release either.  2.3.7.Final is the most recent one for us to use.

Comment 16 Shelly McGowan 2014-08-14 17:37:30 UTC
Commit for community IP BOM without the resteasy upgrade:
https://github.com/smcgowan/jboss-integration-platform-bom/commit/f3c438fe67ffd441a375d4357b9454d534fa09d0

Comment 31 Ryan Zhang 2014-09-22 04:43:10 UTC
The PR has been merged to jb-ip-bom. 
It is expected to pick up by DR4.

Comment 32 Petr Široký 2014-12-05 17:48:04 UTC
I just checked the versions against EAP 6.3.2. (current target version for BxMS 6.1). See https://maven.repository.redhat.com/techpreview/all/org/jboss/bom/eap6-supported-artifacts/6.3.2.GA/eap6-supported-artifacts-6.3.2.GA.pom .

Everything modified by this BZ is synced except for Weld. The Weld was updated there to 1.1.25.Final, so I will create PR in ip-bom to sync that up.

I am closing this issues as the initial goal was to sync with EAP 6.3.0 and that was achieved.

Comment 33 Ryan Zhang 2014-12-07 03:26:40 UTC
Thanks for verifying and creating PR!
(In reply to Petr Siroky from comment #32)
> I just checked the versions against EAP 6.3.2. (current target version for
> BxMS 6.1). See
> https://maven.repository.redhat.com/techpreview/all/org/jboss/bom/eap6-
> supported-artifacts/6.3.2.GA/eap6-supported-artifacts-6.3.2.GA.pom .
> 
> Everything modified by this BZ is synced except for Weld. The Weld was
> updated there to 1.1.25.Final, so I will create PR in ip-bom to sync that up.
> 
> I am closing this issues as the initial goal was to sync with EAP 6.3.0 and
> that was achieved.


Note You need to log in before you can comment on or make changes to this bug.